Index: NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/DOM/domvvl.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/DOM/domvvl.F90	(revision 15772)
+++ NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/DOM/domvvl.F90	(revision 15775)
@@ -135,9 +135,4 @@
       !                    !== Set of all other vertical scale factors  ==!  (now and before)
       !                                ! Horizontal interpolation of e3t
-
-      ! Ensure all e3t_b and e3t_n halos are up to date!
-      call lbc_lnk('dom_vvl_init', e3t_b, 'T', 1.0_wp)
-      call lbc_lnk('dom_vvl_init', e3t_n, 'T', 1.0_wp) 
-
       CALL dom_vvl_interpol( e3t_b(:,:,:), e3u_b(:,:,:), 'U' )    ! from T to U
       CALL dom_vvl_interpol( e3t_n(:,:,:), e3u_n(:,:,:), 'U' )
Index: NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/DOM/iscplrst.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/DOM/iscplrst.F90	(revision 15772)
+++ NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/DOM/iscplrst.F90	(revision 15775)
@@ -199,7 +199,4 @@
          END DO
          !
-
-         call lbc_lnk("iscpl_rst_interpol", e3t_n, 'T', 1.0_wp)
-
          CALL dom_vvl_interpol( e3t_n(:,:,:), e3u_n(:,:,:), 'U' )
          CALL dom_vvl_interpol( e3t_n(:,:,:), e3v_n(:,:,:), 'V' )
Index: NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/DYN/dynnxt.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/DYN/dynnxt.F90	(revision 15772)
+++ NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/DYN/dynnxt.F90	(revision 15775)
@@ -248,6 +248,4 @@
             IF( ln_dynadv_vec ) THEN      ! Asselin filter applied on velocity
                ! Before filtered scale factor at (u/v)-points
-               call lbc_lnk("dynnxt", e3t_b, 'T', 1.0_wp)
-
                CALL dom_vvl_interpol( e3t_b(:,:,:), e3u_b(:,:,:), 'U' )
                CALL dom_vvl_interpol( e3t_b(:,:,:), e3v_b(:,:,:), 'V' )
Index: NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/SBC/sbcice_cice.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/SBC/sbcice_cice.F90	(revision 15772)
+++ NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/SBC/sbcice_cice.F90	(revision 15775)
@@ -243,8 +243,4 @@
                ! Horizontal scale factor interpolations
                ! --------------------------------------
-
-               call lbc_lnk("cice_sbc_init", e3t_b, 'T', 1.0_wp)
-               call lbc_lnk("cice_sbc_init", e3t_n, 'T', 1.0_wp)
-
                CALL dom_vvl_interpol( e3t_b(:,:,:), e3u_b(:,:,:), 'U' )
                CALL dom_vvl_interpol( e3t_b(:,:,:), e3v_b(:,:,:), 'V' )
Index: NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/step.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/step.F90	(revision 15772)
+++ NEMO/branches/UKMO/NEMO_4.0.4_GC_couple_pkg/src/OCE/step.F90	(revision 15775)
@@ -93,9 +93,4 @@
       !
       IF( ln_timing )   CALL timing_start('stp')
-
-      CALL lbc_lnk_multi('step',e3u_b,'U',1., e3v_b,'V',1.)
-      CALL lbc_lnk_multi('step',e3u_n,'U',1., e3v_n,'V',1.)
-      CALL lbc_lnk_multi('step',e3t_b,'T',1., e3t_n,'T',1.)
-
       !
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -278,12 +273,4 @@
 !!jc: That would be better, but see comment above
 !!
-      CALL lbc_lnk_multi('step',ub,'U',-1., vb,'V',-1.,tsb(:,:,:,jp_tem),'T',1.,  tsb(:,:,:,jp_sal),'T',1.)
-      CALL lbc_lnk_multi('step',ub,'U',-1., vb,'V',-1.)
-
-      CALL lbc_lnk('step', sshb,'T',1.)
-      CALL lbc_lnk_multi('step',un,'U',-1., vn,'V',-1.,tsn(:,:,:,jp_tem),'T',1., tsn(:,:,:,jp_sal),'T',1., rhop,'T',1.)
-      CALL lbc_lnk_multi('step',un,'U',-1., vn,'V',-1.)
-      CALL lbc_lnk('step', sshn,'T',1.)
-
       IF( lrst_oce   )   CALL rst_write    ( kstp )   ! write output ocean restart file
       IF( ln_sto_eos )   CALL sto_rst_write( kstp )   ! write restart file for stochastic parameters